/*-
 * Copyright (C) @BABOLO  2005 Oct 14
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHORS ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 *  OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#ifndef lint
static const char copyright[] = "\
@(#)Copyright (C)2005 @BABOLO http://www.babolo.ru/\n\
@(#)All rights reserved.\n";
static const char rcsid[] = "$Id: paunck.c,v 1.4 2005/11/29 01:55:33 babolo Exp $";
#endif /* not lint */

#include <sys/types.h>
#include <stdlib.h>
#include <limits.h>
#include <string.h>
#include <stdio.h>
#include "iso8583.h"

/********************************************************************/
/*                       */
/*    , description    '?' */
/********************************************************************/
#include "pack/expo.cc"
#include "pack/test.cc"

static const struct {
    const ISO8583_Package *pack;
    const char *id;
    const char *descr;
} ISO8583_Packages[] =
{{&ISO8583_ExpoBankQPackage, "expoaQ", "  "}
,{&ISO8583_ExpoBankAPackage, "expoaA", "  "}
 /*       */
,{&    ISO8583_Test1Package, "test1" , " 1"             }
,{&    ISO8583_Test2Package, "test2" , " 2"             }
,{(ISO8583_Package*)NULL, (char*)NULL, (char*)NULL}
};

const ISO8583_Package *
ISO8583_Take(char *nm) {
    const ISO8583_Package *e = NULL;
    ssize_t i, j;
    char *t;
    if  (*nm) {
        j = strtoul(nm, &t, 0);
        for (i = 0; ISO8583_Packages[i].id; i++) {
            if  ((*t) ? (!strcmp(nm, ISO8583_Packages[i].id)) : (i == j)) {
                e = ISO8583_Packages[i].pack;
                break;
    }   }   }
    return(e);
}

int
ISO8583_List(int first, int len, FILE *prt) {
    int e, i;
    for (i = first, e = 0; ISO8583_Packages[i].id && (!len || (e < len)); i++, e++) {
        fprintf(prt, "%s\t%s\n", ISO8583_Packages[i].id, ISO8583_Packages[i].descr);
    }
    return(e);
}
